/******************************************************************************
	            MSP430F5438AСϵͳV3.0

ܣ͸
ڲʣ115200

Ӳԭͼ
            TXD --> P3.4
            RXD --> P3.5

//   MSP430F543xA Demo - USCI_A0, 115200 UART Echo ISR, DCO SMCLK

//   Description: Echo a received character, RX ISR used. Normal mode is LPM0.

//   USCI_A0 RX interrupt triggers TX Echo.

//   Baud rate divider with 1048576hz = 1048576/115200 = ~9.1 (009h|01h)

//   ACLK = REFO = ~32768Hz, MCLK = SMCLK = default DCO = 32 x ACLK = 1048576Hz

//   See User Guide for baud rate divider table

//                 MSP430F5438A

//             -----------------

//         /|\|                 |

//          | |                 |

//          --|RST              |

//            |                 |

//            |     P3.4/UCA0TXD|------------>

//            |                 | 115200 - 8N1

//            |     P3.5/UCA0RXD|<------------

//   Built with IAR Embedded Workbench Version: 5.3

Time2014119

******************************************************************************/
#include <msp430x54x.h>

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;           //رտŹ   
  
  P3SEL = 0x30;                       //ѡP3.4 P3.5ڹ
  UCA0CTL1 |= UCSWRST;                // USCI Software Reset */
  UCA0CTL1 |= UCSSEL_2;               // USCI 0 Clock Source: 2  -->  SMCLK
  UCA0BR0 = 9;                        //ò:115200, Ҫ9600򻻳0x6d
  UCA0BR1 = 0;                        //ò
  UCA0MCTL |= UCBRS_1 + UCBRF_0;      // USCI A0 Modulation Control = USCI Second Stage Modulation: 1 + USCI First Stage Modulation: 0  
  UCA0CTL1 &= ~UCSWRST;               //λ״̬
  UCA0IE |= UCRXIE;                   //USCI Receive Interrupt Enable 
  
  __bis_SR_register(LPM0_bits + GIE); //͹ģʽ0ȫж
  __no_operation();
}

/*******************жϷ***********************/
#pragma vector=USCI_A0_VECTOR
__interrupt 
void USCI_A0_ISR(void)                //0ж
{
  switch(__even_in_range(UCA0IV,4))   //ж USCI A0 Interrupt Vector Register Value   
  {
    case 0:break;                     // Vector 0 - no interrupt  
    case 2:                           // Vector 2 - RXIFG
      while (!(UCA0IFG&UCTXIFG));
      UCA0TXBUF = UCA0RXBUF;
      break;
    case 4:break;                     // Vector 4 - TXIFG
    default: break;
  }
}
